;305+
;    scrgrb,   10 室 䠩.
        .model  tiny
        .code
        .186
        org     2ch
envseg  dw      ?
        org     80h
cmd_len         db      ?
cmd_line        db      ?
        org     100h
start:
        jmp     initialize
int09h_handler  proc    far
                jmp     short actual_int09h_handler
old_int09h      dd      ?
                dw      424bh
                db      00h
                jmp     short hw_reset
                db      7 dup (0)
actual_int09h_handler:
                pushf
                call    dword ptr cs:old_int09h
        pusha
        push    ds
        push    es
        push    0040h
        pop     ds
        mov     di,word ptr ds:001ah
        cmp     di,word ptr ds:001ch
        je      exit_09h_handler
        mov     ax,word ptr [di]
        cmp     ah,22h
        jne     exit_09h_handler
        mov     al,byte ptr ds:0017h
        test    al,08h
        je      exit_09h_handler
        mov     word ptr ds:001ch,di
        call    do_grab
        mov     byte ptr cs:io_needed,1
        cli
        call    safe_check
        jc      exit_09h_handler
        sti
        call    do_io
exit_09h_handler:
        pop     es
        pop     ds
        popa
        iret
int09h_handler endp
hw_reset:       retf
int08h_handler  proc    far
        jmp     short actual_int08h_handler
old_int08h      dd      ?
                dw      424bh
                db      00h
        jmp     short hw_reset
                db      7 dup (0)
actual_int08h_handler:
        pushf
        call    dword ptr cs:old_int08h
        pusha
        push    ds
        cli
        cmp     byte ptr cs:io_needed,0
        je      no_io_needed
        call    safe_check
        jc      no_io_needed
        sti
        call    do_io
no_io_needed:
        pop     ds
        popa
        iret
int08h_handler  endp
int13h_handler  proc    far
        jmp     short actual_int13h_handler
old_int13h      dd      ?
                dw      424bh
                db      00h
        jmp     short hw_reset
                db      7 dup (0)
actual_int13h_handler:
        pushf
        inc     byte ptr cs:bios_busy
        cli
        call    dword ptr cs:old_int13h
        pushf
        dec     byte ptr cs:bios_busy
        popf
        ret     2
int13h_handler  endp
int28h_handler  proc    far
        jmp     short actual_int28h_handler
old_int28h      dd      ?
                dw      424bh
                db      00h
        jmp     short hw_reset
                db      7 dup (0)
actual_int28h_handler:
        pushf
        push    di
        push    ds
        push    cs
        pop     ds
        cli
        cmp     byte ptr io_needed,0
        je      no_io_needed2
        lds     di,dword ptr in_dos_addr
        cmp     byte ptr [di+1],1
        ja      no_io_needed2
        sti
        call    do_io
no_io_needed2:
        pop     ds
        pop     di
        popf
        jmp     dword ptr cs:old_int28h
int28h_handler  endp
do_grab proc    near
        push    cs
        pop     ds
        call    ems_init
        mov     dx,word ptr cs:buffer_seg
        mov     es,dx
        mov     ds,dx
        mov     ax,1017h
        mov     bx,0
        mov     cx,256
        mov     dx,bmp_header_length
        int     10h
        std
        mov     si,bmp_header_length+256*3-1
        mov     di,bmp_header_length+256*4-1
        mov     cx,256
adj_pal:        mov     al,0
        stosb
        lodsb
        shl     al,2
        push    ax
        lodsb
        shl     al,2
        push    ax
        lodsb
        shl     al,2
        stosb
        pop     ax
        stosb
        pop     ax
        stosb
        loop    adj_pal
        cld
        push    0a000h
        pop     ds
        mov     si,320*200
        mov     di,bfoffbits
        mov     dx,200
bmp_write_loop:
        mov     cx,320/2
        rep     movsw
        sub     si,320*2
        dec     dx
        jnz     bmp_write_loop
        call    ems_reset
        ret
do_grab endp
file_open       proc    near
;        cmp     [filespec+6],8
;        jbe     go0
;        mov     [filespec+6],0
;go0:
        mov     dx,offset filespec
        mov     ah,03dh
        mov     al,0
        int     21h
        jc      go
        mov     al,[filespec+6]
        inc     al
;        cmp     al,0ah
;        jne     go0
;        xor     al,al
;        jmp     go
;go0:
        mov     [filespec+6],al
        jmp     file_open
go:
        ret
file_open       endp
do_io   proc    near
        push    cs
        pop     ds
        mov     byte ptr io_needed,0
        call    ems_init
;        mov     [filespec+6],0
        call    file_open
        mov     ah,6ch
        mov     bx,2
        mov     cx,0
        mov     dx,12h
        mov     si,offset filespec
        int     21h
        mov     bx,ax
        mov     ah,40h
        mov     cx,bfsize
        mov     ds,word ptr buffer_seg
        mov     dx,0
        int     21h
        mov     ah,68h
        int     21h
        mov     ah,3eh
        int     21h
        call    ems_reset
        ret
do_io   endp
ems_init        proc    near
        cmp     dx,word ptr ems_handle
        cmp     dx,0
        je      ems_init_exit
        mov     ax,4700h
        int     67h
        mov     ax,4100h
        int     67h
        mov     word ptr buffer_seg,bx
        mov     ax,4400h
        mov     bx,0
        int     67h
        mov     ax,4401h
        inc     bx
        int     67h
        mov     ax,4402h
        inc     bx
        int     67h
        mov     ax,4403h
        inc     bx
        int     67h
ems_init_exit:
        ret
ems_init        endp
ems_reset       proc    near
        mov     dx,word ptr cs:ems_handle
        cmp     dx,0
        je      ems_reset_exit
        mov     ax,4800h
        int     67h
ems_reset_exit:
        ret
ems_reset       endp
safe_check      proc    near
        push    es
        push    cs
        pop     ds
        les     di,dword ptr in_dos_addr
        cmp     word ptr es:[di],0
        pop     es
        jne     safe_check_failed
        cmp     byte ptr bios_busy,0
        jne     safe_check_failed
        clc
        ret
safe_check_failed:
        stc
        ret
safe_check      endp
in_dos_addr     dd      ?
io_needed       db      0
bios_busy       db      0
buffer_seg      dw      0
ems_handle      dw      0
filespec        db      'scrgrb0.bmp',0
hw_reset2d:     retf
int2dh_handler  proc    far
        jmp     short actual_int2dh_handler
old_int2dh      dd      ?
                dw      424bh
                db      00h
        jmp     short hw_reset2d
                db      7 dup (0)
actual_int2dh_handler:
                db      80h,0fch
mux_id          db      ?
                je      its_us
                jmp     dword ptr cs:old_int2dh
its_us:
        cmp     al,06
        jae     int2d_no
        cbw
        mov     di,ax
        shl     di,1
        jmp     word ptr cs:jumptable[di]
jumptable       dw      offset int2d_00,offset int2d_no
                dw      offset int2d_02,offset int2d_no
                dw      offset int2d_04,offset int2d_05
int2d_00:
        mov     al,0ffh
        mov     cx,0100h
        push    cs
        pop     dx
        mov     di,offset amis_sign
        iret
int2d_no:
        mov     al,00h
        iret
unload_failed:
        mov     al,01h
        iret
int2d_02:
        cli
        push    0
        pop     ds
        mov     ax,cs
        cmp     ax,word ptr ds:[09h*4+2]
        jne     unload_failed
        cmp     ax,word ptr ds:[13h*4+2]
        jne     unload_failed
        cmp     ax,word ptr ds:[08h*4+2]
        jne     unload_failed
        cmp     ax,word ptr ds:[28h*4+2]
        jne     unload_failed
        cmp     ax,word ptr ds:[2dh*4+2]
        jne     unload_failed
        push    bx
        push    dx
        mov     ax,2509h
        lds     dx,dword ptr cs:old_int09h
        int     21h
        mov     ax,2513h
        lds     dx,dword ptr cs:old_int13h
        int     21h
        mov     ax,2508h
        lds     dx,dword ptr cs:old_int08h
        int     21h
        mov     ax,2528h
        lds     dx,dword ptr cs:old_int28h
        int     21h
        mov     ax,252dh
        lds     dx,dword ptr cs:old_int2dh
        int     21h
        mov     dx,word ptr cs:ems_handle
        cmp     dx,0
        je      no_ems_to_unhook
        mov     ax,4500h
        int     67h
        jmp     short ems_unhooked
no_ems_to_unhook:
ems_unhooked:
        mov     ah,51h
        int     21h
        mov     word ptr cs:[16h],bx
        pop     dx
        pop     bx
        mov     word ptr cs:[0ch],dx
        mov     word ptr cs:[0ah],bx
        push    cs
        pop     bx
        mov     ah,50h
        int     21h
        mov     ax,4cffh
        int     21h
int2d_04:
        mov     dx,cs
        mov     bx,offset amis_hooklist
        iret
int2d_05:
        mov     al,0ffh
        mov     dx,cs
        mov     bx,offset amis_hotkeys
        iret
int2dh_handler   endp
amis_sign       db      "Cubbi..."
                db      "ScrnGrab"
                db      "Simple screen grabber using EMS",0
amis_hooklist   db      09h
                dw      offset int09h_handler
                db      08h
                dw      offset int08h_handler
                db      28h
                dw      offset int28h_handler
                db      2dh
                dw      offset int2dh_handler
amis_hotkeys    db      1
                db      1
                db      22h
                dw      08h
                dw      0
                db      1
initialize      proc    near
        jmp     short initialize_entry_point
exit_with_message:
        mov     ah,9
        int     21h
        ret
already_loaded:
        cmp     byte ptr unloading,1
        je      do_unload
        mov     dx,offset already_msg
        jmp     short exit_with_message
no_more_mux:
        mov     dx,offset no_more_mux_msg
        jmp     short exit_with_message
cant_unload1:
        mov     dx,offset cant_unload1_msg
        jmp     short exit_with_message
do_unload:
        inc     ah
        mov     al,02h
        mov     dx,cs
        mov     bx,offset exit_point
        int     2dh
        push    cs
        pop     ds
        mov     dx,offset cant_unload2_msg
        jmp     short exit_with_message
exit_point:
        push    cs
        pop     ds
        mov     dx,offset unloaded_msg
        push    0
        jmp     short exit_with_message
initialize_entry_point:
        cld
        cmp     byte ptr cmd_line[1],'/'
        jne     not_unload
        cmp     byte ptr cmd_line[2],'u'
        jne     not_unload
        mov     byte ptr unloading,1
not_unload:
        mov     ah,9
        mov     dx,offset usage
        int     21h
        mov     ah,-1
more_mux:
        mov     al,00h
        int     2dh
        cmp     al,00h
        jne     not_free
        mov     byte ptr mux_id,ah
        jmp     short next_mux
not_free:
        mov     es,dx
        mov     si,offset amis_sign
        mov     cx,16
        repe    cmpsb
        jcxz    already_loaded
next_mux:
        dec     ah
        jnz     more_mux
free_mux_found:
        cmp     byte ptr unloading,1
        je      cant_unload1
        cmp     byte ptr mux_id,0
        je      no_more_mux
        mov     dx,offset ems_driver
        mov     ax,3d00h
        int     21h
        jc      no_emmx
        mov     bx,ax
        mov     ax,4400h
        int     21h
        jc      no_ems
        test    dx,80h
        jz      no_ems
        mov     ax,4100h
        int     67h
        mov     bp,bx
        mov     ax,4300h
        mov     bx,4
        int     67h
        cmp     ah,0
        jnz     ems_failed
        mov     word ptr ems_handle,dx
        mov     ax,4400h
        mov     bx,0
        int     67h
        mov     ax,4401h
        inc     bx
        int     67h
        mov     ax,4402h
        inc     bx
        int     67h
        mov     ax,4403h
        inc     bx
        int     67h
        mov     ah,9
        mov     dx,offset ems_msg
        int     21h
        mov     ax,bp
        jmp     short ems_used
ems_failed:
no_ems:
        mov     ah,3eh
        int     21h
no_emmx:
        mov     ah,9
        mov     dx,offset conv_msg
        int     21h
        mov     sp,length_of_program+100h+200h
        mov     ah,4ah
next_segment = length_of_program+100h+200h+0fh
next_segment = next_segment/16
        mov     bx,next_segment
        int     21h
        mov     ah,48h
bfsize_p = bfsize+0fh
bfsize_p = bfsize_p/16
        mov     bx,bfsize_p
        int     21h
ems_used:
        mov     word ptr buffer_seg,ax
        mov     cx,bmp_header_length
        mov     si,offset bmp_header
        mov     di,0
        mov     es,ax
        rep     movsb
        mov     ah,34h
        int     21h
        dec     bx
        mov     word ptr in_dos_addr,bx
        mov     word ptr in_dos_addr+2,es
        mov     ax,352dh
        int     21h
        mov     word ptr old_int2dh,bx
        mov     word ptr old_int2dh+2,es
        mov     ax,3528h
        int     21h
        mov     word ptr old_int28h,bx
        mov     word ptr old_int28h+2,es
        mov     ax,3508h
        int     21h
        mov     word ptr old_int08h,bx
        mov     word ptr old_int08h+2,es
        mov     ax,3513h
        int     21h
        mov     word ptr old_int13h,bx
        mov     word ptr old_int13h+2,es
        mov     ax,3509h
        int     21h
        mov     word ptr old_int09h,bx
        mov     word ptr old_int09h+2,es
        mov     ax,252dh
        mov     dx,offset int2dh_handler
        int     21h
        mov     ax,2528h
        mov     dx,offset int28h_handler
        int     21h
        mov     ax,2508h
        mov     dx,offset int08h_handler
        int     21h
        mov     ax,2513h
        mov     dx,offset int13h_handler
        int     21h
        mov     ax,2509h
        mov     dx,offset int09h_handler
        int     21h
        mov     ah,49h
        mov     es,word ptr envseg
        int     21h
        mov     dx,offset initialize
        int     27h
initialize      endp
ems_driver      db      'EMMXXXX0',0
usage           db      0dh,0ah,' ⭠ ணࠬ .',0dh,0ah
                db      ' ஢ ࠭ ⮫쪮  ० 13h .',0dh,0ah
                db      '   10- 䠩  ⥪饬 ⠫ .',0dh,0ah
                db      ' Alt-G -   ࠭  䠩 scrgrb0-9.bmp .',0dh,0ah
                db      ' scrgrb.com /u - 㧨   .',0dh,0ah,'$'
ems_msg         db      ' ணࠬ 㦥  EMS .',0dh,0ah,'$'
conv_msg        db      ' ணࠬ  㦥  EMS .',0dh,0ah,'$'
unloaded_msg    db      ' ணࠬ ᯥ譮 㦥   .',0dh,0ah,'$'
already_msg     db      ' 訡 ! ணࠬ 㦥 㦥 .',0dh,0ah,'$'
no_more_mux_msg db      ' 訡 ! 誮  १ ணࠬ .',0dh,0ah,'$'
cant_unload1_msg        db      ' 訡 ! ணࠬ  㦥   .',0dh,0ah,'$'
cant_unload2_msg        db      ' 訡 ! 㣠 ணࠬ 墠⨫ 뢠 .',0dh,0ah,'$'
unloading       db      0
bmp_header      label   byte
bmp_file_header db      "BM"
                dd      bfsize
                dw      0,0
                dd      bfoffbits
bmp_info_header dd      bi_size
                dd      320
                dd      200
                dw      1
                dw      8
                dd      0
                dd      320*200
                dd      0b13h
                dd      0b13h
                dd      0
                dd      0
bi_size = $-bmp_info_header
bmp_header_length = $-bmp_header
bfoffbits = $-bmp_file_header+256*4
bfsize = $-bmp_file_header+256*4+320*200
length_of_program = $-start
        end     start





