;276
;뢠, ࠢ騥 ᫥⥫ , ନ 
;᪠   設
        ideal
        model small
        stack 256
cr      equ     13
lf      equ     10
bd9600  equ     0e3h
exitkey equ     100
;***************************
comport=0
if comport eq 0
 port equ 03f8h
 vectornum equ 0ch
 enableirq equ 0efh
 disableirq equ 10h
else if comport eq 1
 port equ 02f8h
 vectornum equ 0bh
 enableirq equ 0f7h
 disableirq equ 08h
else
 display "comport must be 0 or 1"
 err
endif
txregister      =port+0
rxregister      =port+0
intenable       =port+1
intident        =port+2
linecontrol     =port+3
modemcontrol    =port+4
linestatus      =port+5
modemstatus       =port+6
ctrl8259_0      equ     020h
ctrl8259_1      equ     021h
eoi     equ     020h
bufsize equ     2048
;********************************
        dataseg
excode  db      0
welcome db      'Terminal emulator.',cr,lf
        db      cr,lf,'Configured for 9600 baud.'
        db      cr,lf,'Displays control codes in brackets for debugging'
        db      cr,lf,'an RS232 serial line.'
        db      cr,lf,'Press F10 to exit.',cr,lf,0
string  db      80 dup(?)
;*******************************************
vectorseg       dw      ?
vectorofs       dw      ?
bufhead         dw      ?
buftail         dw      ?
buffer          db      bufsize dup(?)
;*********************************************
        codeseg
;**********************************************
proc    emptybuffer
        cli
        push    ax
        mov     ax,offset buffer
        mov     [bufhead],ax
        mov     [buftail],ax
        pop     ax
        sti
        ret
endp    emptybuffer
proc    asynchinit
        call    emptybuffer
        push    ds
        push    es
        mov     ax,3500h+vectornum
        int     21h
        mov     [vectorseg],es
        mov     [vectorofs],bx
        push    cs
        pop     ds
        mov     dx,offset asynchisr
        mov     ax,2500h+vectornum
        int     21h
        pop     es
        pop     ds
        in      al,ctrl8259_1
        and     al,enableirq
        out     ctrl8259_1,al
        mov     dx,linecontrol
        in      al,dx
        and     al,07fh
        out     dx,al
        mov     dx,intenable
        mov     al,1
        out     dx,al
@@10:
        mov     dx,rxregister
        in      al,dx
        mov     dx,linestatus
        in      al,dx
        mov     dx,modemstatus
        in      al,dx
        mov     dx,intident
        in      al,dx
        test    al,1
        jz      @@10
        mov     dx,modemcontrol
        in      al,dx
        or      al,08h
        out     dx,al
        call    emptybuffer
        ret
endp    asynchinit
proc    asynchstop
        in      al,ctrl8259_1
        or      al,disableirq
        out     ctrl8259_1,al
        mov     dx,linecontrol
        in      al,dx
        and     al,07fh
        out     dx,al
        mov     dx,intenable
        xor     al,al
        out     dx,al
        mov     dx,modemcontrol
        in      al,dx
        and     al,07fh
        out     dx,al
        push    ds
        mov     ax,2500h+vectornum
        mov     dx,[vectorofs]
        mov     ds,[vectorseg]
        int     21h
        pop     ds
        ret
endp    asynchstop
proc    asynchstat
        mov     ah,3
        mov     dx,comport
        int     14h
        ret
endp    asynchstat
proc    asynchout
        push    dx
        push    ax
@@10:
        mov     dx,linestatus
        in      al,dx
        and     al,020h
        jz      @@10
        pop     ax
        mov     dx,txregister
        out     dx,al
        pop     dx
        ret
endp    asynchout
proc    asynchin
        xor     al,al
        mov     bx,[buftail]
        cmp     bx,[bufhead]
        je      @@99
        mov     al,[byte ptr bx]
        inc     [buftail]
        cmp     [word ptr buftail],offset buffer+bufsize
        jb      @@99
        mov     [buftail],offset buffer
@@99:
        ret
endp    asynchin
proc    asynchinstat
        mov     dx,[bufhead]
        sub     dx,[buftail]
        jge     @@99
        add     dx,bufsize
@@99:
        ret
endp    asynchinstat
proc    asynchisr
        push    ax
        push    bx
        push    ds
        push    dx
        mov     ax,@data
        mov     ds,ax
        mov     dx,rxregister
        in      al,dx
        mov     bx,[bufhead]
        mov     [byte ptr bx],al
        inc     bx
        cmp     bx,offset buffer+bufsize
        jb      @@10
        mov     bx,offset buffer
@@10:
        cmp     bx,[buftail]
        jne     @@20
        mov     bx,[bufhead]
@@20:
        mov     [bufhead],bx
        mov     al,eoi
        out     ctrl8259_1,al
        pop     dx
        pop     ds
        pop     bx
        pop     ax
        iret
endp    asynchisr
;*****************************************
proc keywaiting
        push    ax
        mov     ah,1
        int     16h
        pop     ax
        ret
endp keywaiting
proc getch
        xor     ah,ah
        int     16h
        or      al,al
        jnz     @@10
        xchg    ah,al
        add     al,32
        jmp     short @@20
@@10:
        xor     ah,ah
        cmp     al,32
        jb      @@20
        inc     ah
@@20:
        or      ah,ah
        ret
endp getch
proc hexdigit
        cmp     dl,10
        jb      @@10
        add     dl,'A'-10
        ret
@@10:
        or      dl,'0'
        ret
endp hexdigit
proc numtoascii
        push    dx
        push    di
        push    si
        xor     si,si
        jcxz    @@20
@@10:
        xor     dx, dx
        div     bx
        call    hexdigit
        push    dx
        inc     si
        loop    @@10
@@20:
        inc     cx
        or      ax,ax
        jnz     @@10
        mov     cx,si
        jcxz    @@40
        cld
@@30:
        pop     ax
        stosb
        loop    @@30
@@40:
        mov     [byte di],0
        pop     si
        pop     di
        pop     dx
        ret
endp numtoascii
proc bintoascdec
        push    bx
        mov     bx,10
        call    numtoascii
        pop     bx
        ret
endp bintoascdec
proc  strlength
        push    ax
        push    di
        xor     al,al
        mov     cx,0ffffh
        cld
        repnz   scasb
        not     cx
        dec     cx
        pop     di
        pop     ax
        ret
endp strlength
proc strwrite
        call    strlength
        push    ax
        push    bx
        push    dx
        mov     bx, 1
        mov     dx, di
        mov     ah, 40h
        int     21h
        pop     dx
        pop     bx
        pop     ax
        ret
endp strwrite

start:
        mov     ax,@data
        mov     ds,ax
        mov     es,ax
        mov     di,offset welcome
        call    strwrite
        mov     ah,0
        mov     al,bd9600
        mov     dx,comport
        int     14h
        call    asynchinit
emulate:
        call    asynchinstat
        or      dx,dx
        jz      @@10
        call    asynchin
        call    dispchar
        jmp     emulate
@@10:
        call    keywaiting
        jz      emulate
        call    getch
        jnz     @@20
        cmp     al,exitkey
        je      exit
@@20:
        call    asynchout
        jmp     emulate
exit:
        call    asynchstop
        mov     ah,04ch
        mov     al,[excode]
        int     21h
proc    dispchar
        cmp     al,32
        jae     onechar
        xor     ah,ah
        mov     cx,1
        mov     di,offset string
        call    bintoascdec
        mov     al,'['
        call    onechar
        call    strwrite
        mov     al,']'
proc    onechar
        mov     dl,al
        mov     ah,2
        int     21h
        ret
endp    onechar
endp    dispchar
end     start
